#version 130

// required by GLSL spec Sect 4.5.3 (though nvidia does not, amd does)
precision highp float;

uniform vec3 material_diffuse_color; 
uniform bool has_diffuse_texture; 
uniform sampler2D diffuse_texture;
uniform vec3 viewSpaceLightPos;


in  vec2 texCoord;
out vec4 fragmentColor;

void main() 
{
	vec3 materialDiffuse = (has_diffuse_texture ? texture(diffuse_texture, texCoord.xy).xyz : material_diffuse_color);
	fragmentColor = vec4(materialDiffuse, 1.0);
}