#version 130

in vec3		vertex;
in vec3		colorIn;
out vec4	color;
in	vec2	texCoordIn;	// incoming texcoord from the texcoord array
out	vec2	texCoord;	// outgoing interpolated texcoord to fragshader
in  vec3	normalIn;
out vec3	normal;

out vec4 shadowTexCoord;

uniform mat4 modelViewProjectionMatrix; 
uniform mat4 normalMatrix; 
uniform mat4 lightMatrix;	// This is the modelviewprojection-matrix for the light's view

void main() 
{
	gl_Position = modelViewProjectionMatrix*vec4(vertex,1);
	color = vec4(colorIn,1); 
	texCoord = texCoordIn; 
	normal = normalize( (normalMatrix * vec4(normalIn,0.0)).xyz );
	
	// This is the code related to using shadow maps
	shadowTexCoord = lightMatrix * vec4(vertex,1);	// Transform vertex into light's unit space
	shadowTexCoord.xyz *= vec3(0.5f, 0.5f, 0.5f);	// Remap texture coordinates from 
	shadowTexCoord.xyz += shadowTexCoord.w * vec3(0.5f, 0.5f, 0.5f);	// [-1,-1,-1]-[1,1,1] to [0,0,0]-[1,1,1] (Note that this could easily be incorporated into the lightMatrix)
}